abuild.in 46.9 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# abuild - build apk packages (light version of makepkg)
Natanael Copa's avatar
Natanael Copa committed
4 5 6 7 8
# Copyright (c) 2008 Natanael Copa <natanael.copa@gmail.com>
#
# Distributed under GPL-2
#

Natanael Copa's avatar
Natanael Copa committed
9 10
abuild_ver=@VERSION@
sysconfdir=@sysconfdir@
11
abuildrepo_base=@abuildrepo@
Natanael Copa's avatar
Natanael Copa committed
12
datadir=@datadir@
Natanael Copa's avatar
Natanael Copa committed
13

14
program=${0##*/}
15
abuild_path=$(readlink -f $0)
Natanael Copa's avatar
Natanael Copa committed
16 17

# defaults
18
BUILD_BASE="build-base"
19
FAKEROOT=${FAKEROOT:-"fakeroot"}
20

21 22
: ${SUDO_APK:=abuild-apk}
: ${APK:=apk}
23 24 25
: ${ADDUSER:=abuild-adduser}
: ${ADDGROUP:=abuild-addgroup}

26
apk_opt_wait="--wait 30"
27

Natanael Copa's avatar
Natanael Copa committed
28
# read config
Natanael Copa's avatar
Natanael Copa committed
29
ABUILD_CONF=${ABUILD_CONF:-"$sysconfdir/abuild.conf"}
Natanael Copa's avatar
Natanael Copa committed
30 31
[ -f "$ABUILD_CONF" ] && . "$ABUILD_CONF"

32
default_colors() {
Natanael Copa's avatar
Natanael Copa committed
33 34 35 36 37 38
	NORMAL="\033[1;0m"
	STRONG="\033[1;1m"
	RED="\033[1;31m"
	GREEN="\033[1;32m"
	YELLOW="\033[1;33m"
	BLUE="\033[1;34m"
39 40 41 42 43 44 45 46 47 48 49 50 51 52
}

monochrome() {
	NORMAL=""
	STRONG=""
	RED=""
	GREEN=""
	YELLOW=""
	BLUE=""
}

#colors
if [ -n "$USE_COLORS" ]; then
    default_colors
53 54 55 56 57 58 59
fi

# run optional log command for remote logging
logcmd() {
	${ABUILD_LOG_CMD:-true} "$@"
	return 0
}
Natanael Copa's avatar
Natanael Copa committed
60 61 62

# functions
msg() {
63
	[ -n "$quiet" ] && return 0
Natanael Copa's avatar
Natanael Copa committed
64 65 66
	local prompt="$GREEN>>>${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
67 68 69 70 71 72 73
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

msg2() {
	[ -n "$quiet" ] && return 0
	#      ">>> %s"
	printf "    %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
74 75 76 77 78 79
}

warning() {
	local prompt="${YELLOW}>>> WARNING:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
80 81 82 83
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
}

warning2() {
84
	#      ">>> WARNING:
85
	printf "             %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
86 87 88 89 90 91
}

error() {
	local prompt="${RED}>>> ERROR:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
92
	printf "${prompt} ${name}${fake}: %s\n" "$1" >&2
93
	logcmd "ERROR: $pkgname: $1"
94 95 96
}

error2() {
97
	#      ">>> ERROR:
98
	printf "           %s\n" "$1" >&2
Natanael Copa's avatar
Natanael Copa committed
99
}
Natanael Copa's avatar
Natanael Copa committed
100

Linux User's avatar
Linux User committed
101
set_xterm_title() {
102
	if [ "$TERM" = xterm ] && [ -n "$USE_COLORS" ]; then
103
		 printf "\033]0;$1\007" >&2
Linux User's avatar
Linux User committed
104
	fi
105
}
Linux User's avatar
Linux User committed
106 107 108

cleanup() {
	set_xterm_title ""
109
	if [ -z "$install_after" ] && [ -n "$uninstall_after" ]; then
110
		msg "Uninstalling dependencies..."
111
		$SUDO_APK del --quiet $apk_opt_wait $uninstall_after
112
	fi
113 114 115
	if [ -n "$CLEANUP_FILES" ]; then
		rm -f $CLEANUP_FILES
	fi
Linux User's avatar
Linux User committed
116 117
}

Natanael Copa's avatar
Natanael Copa committed
118
die() {
Linux User's avatar
Linux User committed
119
	error "$@"
Linux User's avatar
Linux User committed
120
	cleanup
Natanael Copa's avatar
Natanael Copa committed
121 122 123
	exit 1
}

124 125 126 127
spell_error() {
	die "APKBUILD contains '$1'. It should be '$2'"
}

128
# check if apkbuild is basicly sane
129
default_sanitycheck() {
130
	local i= j= suggestion=
131
	msg "Checking sanity of $APKBUILD..."
132 133 134
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
135
	if [ "$pkgver" != "volatile" ] && [ -z "$nodeps" ]; then
136
		$APK version --check --quiet "$pkgver" ||\
Natanael Copa's avatar
Natanael Copa committed
137 138
			die "$pkgver is not a valid version"
	fi
139
	[ -z "$pkgrel" ] && die "Missing pkgrel in APKBUILD"
140 141 142
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"
Natanael Copa's avatar
Natanael Copa committed
143 144 145
	if [ $(echo "$pkgdesc" | wc -c) -gt 128 ]; then
		die "pkgdesc is too long"
	fi
146
	is_function package || warning "Missing package() function in APKBUILD"
147

Natanael Copa's avatar
Natanael Copa committed
148 149
	if [ -n "$replaces_priority" ] \
		&& ! echo $replaces_priority | egrep -q '^[0-9]+$'; then
150 151
		die "replaces_priority must be a number"
	fi
152 153 154 155 156 157 158
	# check so no package names starts with -
	for i in $pkgname $subpackages; do
		case $i in
		-*) die "${i%:*} is not a valid package name";;
		esac
	done

159
	# check if CARCH, CBUILD, CHOST and CTARGET is set
160 161 162 163
	[ -z "$CHOST" ] && die "Please set CHOST in /etc/abuild.conf"
	[ -z "$CBUILD" ] && CBUILD="$CHOST"
	[ -z "$CTARGET" ] && CTARGET="$CHOST"

164
	if [ -z "$CARCH" ]; then
Natanael Copa's avatar
Natanael Copa committed
165
		die "Please fix CHOST, or set CARCH in abuild.conf"
166
	fi
167

Natanael Copa's avatar
Natanael Copa committed
168
	for i in $install; do
169
		local n=${i%.*}
170
		local suff=${i##*.}
171 172 173 174 175
		case "$suff" in
		pre-install|post-install|pre-upgrade|post-upgrade|pre-deinstall|post-deinstall);;
		*) die "$i: unknown install script suffix"
		esac
		if ! subpackages_has "$n" && [ "$n" != "$pkgname" ]; then
176
			die "$i: install script does not match pkgname or any subpackage"
177
		fi
178
		[ -e "$startdir/$i" ] || die "install script $i is missing"
179 180 181 182 183 184
		for j in chown chmod chgrp; do
			if grep -q $j "$startdir"/$i; then
				warning "$i: found $j"
				warning2 "Permissions should be fixed in APKBUILD package()"
			fi
		done
Natanael Copa's avatar
Natanael Copa committed
185
	done
186

187 188 189
	for i in $triggers; do
		local f=${i%=*}
		local p=${f%.trigger}
190
		[ "$f" = "$i" ] && die "$f: triggers must contain '='"
191 192 193 194
		[ "$p" = "$f" ] && die "$f: triggers scripts must have .trigger suffix"
		if ! subpackages_has "$p" && [ "$p" != "$pkgname" ]; then
			die "$p: trigger script does not match pkgname or any subpackage"
		fi
Natanael Copa's avatar
Natanael Copa committed
195

196 197
		[ -e "$startdir"/$f ] || die "trigger script $f is missing"
	done
198 199
	if [ -n "$source" ]; then
		for i in $source; do
Natanael Copa's avatar
Natanael Copa committed
200 201 202 203
			if install_has "$i"; then
				warning "You should not have \$install in source"
				continue
			fi
Natanael Copa's avatar
Natanael Copa committed
204
			case "$i" in
205
				*::*) i=${i%%::*};;
206
				https://*) makedepends_has wget && warning "wget no longer need to be in makedepends when source has https://" ;;
Natanael Copa's avatar
Natanael Copa committed
207
			esac
208 209
			list_has ${i##*/} $md5sums $sha256sums $sha512sums \
				|| die "${i##*/} is missing in checksums"
210 211
		done
	fi
Natanael Copa's avatar
Natanael Copa committed
212

213 214 215 216 217 218 219 220
	# verify that things listed in checksum also is listed in source
	local algo=
	for algo in md5 sha256 sha512; do
		eval set -- \$${algo}sums
		while [ $# -gt 1 ]; do
			local file="$2"
			shift 2
			source_has $file || die "$file exists in ${algo}sums but is missing in source"
221
		done
222
	done
223

224
	# common spelling errors
225 226 227 228 229
	[ -n "$depend" ] && spell_error depend depends
	[ -n "$makedepend" ] && spell_error makedepend makedepends
	[ -n "$pkguser" ] && spell_error pkguser pkgusers
	[ -n "$pkggroup" ] && spell_error pkggroup pkggroups
	[ -n "$subpackage" ] && spell_error subpackage subpackages
Natanael Copa's avatar
Natanael Copa committed
230 231

	grep '^# Maintainer:' $APKBUILD >/dev/null || warning "No maintainer"
232 233

	makedepends_has 'g++' && warning "g++ should not be in makedepends"
234 235 236
	return 0
}

237 238 239 240
sanitycheck() {
	default_sanitycheck
}

241 242
sumcheck() {
	local algo="$1" sums="$2"
243
	local dummy f endreturnval originalparams origin file
244 245 246 247 248 249 250 251

	# get number of checksums
	set -- $sums
	local numsums=$(( $# / 2 ))

	set -- $source
	if [ $# -ne $numsums ]; then
		die "Number of ${algo}sums($numsums) does not correspond to number of sources($#)"
252
	fi
253
	fetch || return 1
254
	msg "Checking ${algo}sums..."
Natanael Copa's avatar
Natanael Copa committed
255
	cd "$srcdir" || return 1
256 257
	IFS=$'\n'
	endreturnval=0
258
	for src in $sums; do
259
		origin=$1; shift
260
		echo "$src" | ${algo}sum -c
261
		if [ $? -ne 0 ]; then
262
			endreturnval=1
263
			is_remote $origin || continue
264
			echo "Because the remote file above failed the ${algo}sum check it will be deleted."
265 266 267 268 269 270 271 272
			echo "Rebuilding will cause it to re-download which in some cases may fix the problem."
			file=`echo "$src" | sed 's/.*[ \t\n]\(.*\)/\1/'`
			echo "Deleting: $file"
			rm $file
		fi
	done
	unset IFS
	return $endreturnval
Natanael Copa's avatar
Natanael Copa committed
273 274
}

275 276 277 278 279 280 281 282 283
# for compatibility
md5check() {
	warning "'md5check' is deprecated. Use 'verify' instead"
	sumcheck md5 "$md5sums"
}

# verify checksums
verify() {
	local verified=false algo=
284
	for algo in sha512 sha256 sha1 md5; do
285 286 287 288 289 290 291
		local sums=
		eval sums=\"\$${algo}sums\"
		if [ -z "$sums" ] || [ -z "$source" ]; then
			continue
		fi
		sumcheck "$algo" "$sums" || return 1
		verified=true
292
		break
293 294 295 296 297 298 299
	done
	if [ -n "$source" ] && ! $verified; then
		die "Use 'abuild checksum' to generate/update the checksum(s)"
	fi
	return 0
}

Natanael Copa's avatar
Natanael Copa committed
300 301
# verify upstream sources
sourcecheck() {
302 303 304 305 306 307 308 309
	local uri
	for uri in $source; do
		is_remote $uri || continue
		case "$uri" in
		saveas-*://*)
			uri=${uri#saveas-}
			uri=${uri%/*}
			;;
310 311 312
		*::*)
			uri=${uri##*::}
			;;
313 314
		esac
		wget -q -s "$uri" || return 1
Natanael Copa's avatar
Natanael Copa committed
315
	done
316
	return 0
Natanael Copa's avatar
Natanael Copa committed
317
}
318

319 320 321
# convert curl options to wget options and call wget instead of curl
wget_fallback() {
	local wget_opts= outfile= opt=
322
	while getopts "C:Lko:s" opt; do
323
		case $opt in
324
		'L') ;; # --location. wget does this by default
325
		'f') ;; # --fail. wget does this by default
326 327 328 329 330 331 332 333 334 335
		'C') wget_opts="$wget_opts -c";; # --continue-at
		's') wget_opts="$wget_opts -q";; # --silent
		'o') wget_opts="$wget_opts -O $OPTARG";; # --output
		'k') wget_opts="$wget_opts --no-check-certificate";; #gnu wget
		esac
	done
	shift $(( $OPTIND - 1 ))
	wget $wget_opts "$1"
}

Natanael Copa's avatar
Natanael Copa committed
336 337
uri_fetch() {
	local uri="$1"
338
	local d="${uri##*/}"	# $(basename $uri)
339
	local opts
340
	[ -n "$quiet" ] && opts="-s"
341 342

	local lockfile="$SRCDEST/$d".lock
343

344 345 346 347 348
	# fix saveas-*://* URIs
	case "$uri" in
		# remove 'saveas-' from beginning and
		# '/filename' from end of URI
		saveas-*://*) uri="${uri:7:$(expr ${#uri} - 7 - ${#d} - 1)}";;
349 350 351 352 353

		*::*)
			d=${uri%%::*}
			uri=${uri#$d::}
			;;
Natanael Copa's avatar
Natanael Copa committed
354
	esac
355 356

	case "$uri" in
357
		https://*) opts="-k";;
358
	esac
359

Natanael Copa's avatar
Natanael Copa committed
360
	mkdir -p "$SRCDEST"
361 362 363

	CLEANUP_FILES="$CLEANUP_FILES $lockfile"
	(
364 365
	flock -n -x 9 || msg "Waiting for ${lockfile##*/}..."
	flock -x 9
366 367 368

	[ -f "$SRCDEST/$d" ] && exit 0 # use exit since its a subshell

369 370
	if [ -f "$SRCDEST/$d.part" ]; then
		msg "Partial download found. Trying to resume"
371
		opts="$opts -C -"
Natanael Copa's avatar
Natanael Copa committed
372
	fi
Linux User's avatar
Linux User committed
373
	msg "Fetching $uri"
374 375

	# fallback to wget if curl is missing. useful for bootstrapping
376
	local fetcher=
377 378
	if ! [ -x "$(which curl)" ]; then
		fetcher=wget_fallback
379 380
	else
		fetcher=curl
381
		opts="$opts -L -f -k"
382 383 384
	fi

	$fetcher $opts -o "$SRCDEST/$d.part" "$uri" \
385
		&& mv "$SRCDEST/$d.part" "$SRCDEST/$d"
386

387
	) 9>$lockfile
388 389 390 391

	local rc=$?
	rm -f "$lockfile"
	return $rc
Natanael Copa's avatar
Natanael Copa committed
392 393
}

394
is_remote() {
395
	case "${1#*::}" in
396
		http://*|ftp://*|https://*|saveas-*://*)
397 398 399 400 401
			return 0;;
	esac
	return 1
}

402 403 404 405 406 407 408 409 410
filename_from_uri() {
	local uri="$1"
	local filename="${uri##*/}"  # $(basename $uri)
	case "$uri" in
	*::*) filename=${uri%%::*};;
	esac
	echo "$filename"
}

411 412 413 414
# try download from file from mirror first
uri_fetch_mirror() {
	local uri="$1"
	if [ -n "$DISTFILES_MIRROR" ]; then
415
		if is_remote "$DISTFILES_MIRROR"; then
416 417
			uri_fetch "$DISTFILES_MIRROR"/$(filename_from_uri $uri)\
				&& return 0
418
		else
419 420
			cp "$DISTFILES_MIRROR"/$(filename_from_uri $uri) \
				"$SRCDEST" && return 0
421
		fi
422 423 424 425
	fi
	uri_fetch "$uri"
}

426
default_fetch() {
Natanael Copa's avatar
Natanael Copa committed
427 428
	local s
	mkdir -p "$srcdir"
429 430
	for s in $source; do
		if is_remote "$s"; then
431
			uri_fetch_mirror "$s" || return 1
432
			ln -sf "$SRCDEST/$(filename_from_uri $s)" "$srcdir"/
433
		else
434 435
			ln -sf "$startdir/$s" "$srcdir/"
		fi
Natanael Copa's avatar
Natanael Copa committed
436 437 438
	done
}

439 440 441 442
fetch() {
	default_fetch
}

Natanael Copa's avatar
Natanael Copa committed
443 444 445 446 447 448 449 450 451 452 453 454
# verify that all init.d scripts are openrc runscripts
initdcheck() {
	local i
	for i in $source; do
		case $i in
		*.initd)
			head -n 1 "$srcdir"/$i | grep -q '/sbin/runscript' \
				&& continue
			error "$i is not an openrc #!/sbin/runscript"
			return 1
			;;
		esac
455
	done
Natanael Copa's avatar
Natanael Copa committed
456 457
}

Natanael Copa's avatar
Natanael Copa committed
458
# unpack the sources
459
default_unpack() {
Natanael Copa's avatar
Natanael Copa committed
460
	local u
461
	if [ -z "$force" ]; then
462
		verify || return 1
Natanael Copa's avatar
Natanael Copa committed
463
		initdcheck || return 1
464
	fi
Natanael Copa's avatar
Natanael Copa committed
465 466
	mkdir -p "$srcdir"
	for u in $source; do
467
		local s="$SRCDEST/$(filename_from_uri $u)"
Natanael Copa's avatar
Natanael Copa committed
468
		case "$s" in
469 470 471
			*.tar)
				msg "Unpacking $s..."
				tar -C "$srcdir" -xf "$s" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
472
			*.tar.gz|*.tgz)
473
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
474 475
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
476
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
477
				tar -C "$srcdir" -jxf "$s" || return 1;;
478 479 480 481
			*.tar.lzma)
				msg "Unpacking $s..."
				unlzma -c "$s" | tar -C "$srcdir" -x  \
					|| return 1;;
482 483 484
			*.tar.xz)
				msg "Unpacking $s..."
				unxz -c "$s" | tar -C "$srcdir" -x || return 1;;
Natanael Copa's avatar
Natanael Copa committed
485 486 487
			*.zip)
				msg "Unpacking $s..."
				unzip "$s" -d "$srcdir" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
488 489 490 491
		esac
	done
}

492 493 494 495
unpack() {
	default_unpack
}

Natanael Copa's avatar
Natanael Copa committed
496 497
# cleanup source and package dir
clean() {
498
	msg "Cleaning temporary build dirs..."
Natanael Copa's avatar
Natanael Copa committed
499
	rm -rf "$srcdir"
500
	rm -rf "$pkgbasedir"
Natanael Copa's avatar
Natanael Copa committed
501 502 503 504 505 506
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
507
		if is_remote "$s"; then
508 509 510
			s=$(filename_from_uri $s)
			msg "Cleaning downloaded $s ..."
			rm -f "$SRCDEST/$s"
511
		fi
Natanael Copa's avatar
Natanael Copa committed
512 513 514
	done
}

515 516 517 518 519 520 521 522 523 524
listpkgnames() {
	local i
	for i in $pkgname $subpackages; do
		echo ${i%:*}
	done
	for i in $linguas; do
		echo $pkgname-lang-$i
	done
}

Natanael Copa's avatar
Natanael Copa committed
525 526
cleanpkg() {
	local i
527
	getpkgver || return 1
528
	msg "Cleaning built packages..."
529
	for i in $(listpkgnames); do
530 531
		local p="${i%:*}-$pkgver-r$pkgrel"
		rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz" \
532
			"$abuildrepo"/$p.apk "$abuildrepo"/*/$p.apk
Natanael Copa's avatar
Natanael Copa committed
533
	done
534
	# remove given packages from index
535
	update_abuildrepo_index
Natanael Copa's avatar
Natanael Copa committed
536 537
}

538 539 540
# clean all packages except current
cleanoldpkg() {
	local i j
541
	getpkgver || return 1
542
	msg "Cleaning all packages except $pkgver-r$pkgrel..."
543
	for i in $(listpkgnames); do
544 545 546 547 548
		local pn=${i%:*}
		for j in "$PKGDEST"/$pn-[0-9]*.apk ; do
			[ "$j" = "$PKGDEST/$pn-$pkgver-r$pkgrel.apk" ] \
				&& continue
			rm -f "$j" "$abuildrepo"/*/${j##*/}
549 550 551 552
		done
	done
	return 0
}
553 554 555

mkusers() {
	local i
556 557 558 559 560 561
	for i in $pkggroups; do
		if ! getent group $i >/dev/null; then
			msg "Creating group $i"
			$ADDGROUP -S $i || return 1
		fi
	done
562 563
	for i in $pkgusers; do
		if ! getent passwd $i >/dev/null; then
564
			local gopt=
565
			msg "Creating user $i"
566 567 568
			if getent group $i >/dev/null; then
				gopt="-G $i"
			fi
569
			$ADDUSER -S -D -H $gopt $i || return 1
570 571 572 573
		fi
	done
}

Natanael Copa's avatar
Natanael Copa committed
574 575
# helper to update config.sub to a recent version
update_config_sub() {
576
	local changed=false
Natanael Copa's avatar
Natanael Copa committed
577
	find . -name config.sub | while read f; do
578 579
		if ! ./$f armv6-alpine-linux-muslgnueabihf 2>/dev/null; then
			msg "Updating $f"
580 581 582
			cp "$datadir"/${f##*/} "$f" || return 1
			changed=true
		else
583
			msg "Not new enough $f"
584 585 586
		fi
		# pipe subshell will return status of last command
		$changed
Natanael Copa's avatar
Natanael Copa committed
587
	done
588
	return $?
Natanael Copa's avatar
Natanael Copa committed
589
}
590

Natanael Copa's avatar
Natanael Copa committed
591 592
runpart() {
	local part=$1
593
	[ -n "$DEBUG" ] && msg "$part"
Natanael Copa's avatar
Natanael Copa committed
594 595 596 597
	$part || die "$part failed"
}

# override those in your build script
598 599 600 601 602 603 604 605
getpkgver() {
	# this func is supposed to be overridden by volatile packages
	if [ "$pkgver" = "volatile" ]; then
		error "Please provide a getpkgver() function in your APKBUILD"
		return 1
	fi
}

Natanael Copa's avatar
Natanael Copa committed
606 607 608 609
prepare() {
	:
}

Natanael Copa's avatar
Natanael Copa committed
610
build() {
611
	:
Natanael Copa's avatar
Natanael Copa committed
612 613
}

614 615 616
# generate a simple tar.gz package of pkgdir
targz() {
	cd "$pkgdir" || return 1
Natanael Copa's avatar
Natanael Copa committed
617
	mkdir -p "$PKGDEST"
618 619 620
	tar -czf "$PKGDEST"/$pkgname-$pkgver-r$pkgrel.tar.gz *
}

Natanael Copa's avatar
Natanael Copa committed
621 622 623 624 625 626 627 628 629
get_split_func() {
	# get the 'func' from "sub-pkg:func"
	local func=${1##*:}

	# get 'func' from "sub-pkg-func" if there was no :func
	[ "$func" = "$1" ] && func=${func##*-}
	echo $func
}

630 631 632
postcheck() {
	local dir="$1" name="$2" i=
	msg "Running postcheck for $name"
633
	# checking for FHS compat
Natanael Copa's avatar
Natanael Copa committed
634 635 636 637 638 639 640 641
	if ! options_has "!fhs"; then
		for i in "$dir"/srv/* "$dir"/usr/local/* "$dir"/opt/*; do
			if [ -e "$i" ]; then
				error "Packages must not put anything under /srv, /usr/local or /opt"
				return 1
			fi
		done
	fi
642 643 644 645 646 647 648
	# look for *.la files
	i=$(find "$dir" -name '*.la' | sed "s|^$dir|\t|")
	if [ -n "$i" ] && ! options_has "libtool"; then
		error "Libtool archives (*.la) files found and \$options has no 'libtool' flag:"
		echo "$i"
		return 1
	fi
649 650 651 652 653 654
	# look for /usr/lib/charset.alias
	if [ -e "$dir"/usr/lib/charset.alias ] \
			&& ! options_has "charset.alias"; then
		error "Found /usr/lib/charset.alias"
		return 1
	fi
655 656 657 658 659 660
	# check directory permissions
	i=$(find "$dir" -type d -perm -777 | sed "s|^$dir|\t|")
	if [ -n "$i" ]; then
		warning "World writeable directories found:"
		echo "$i"
	fi
661
	# check so we dont have any suid root binaries that are not
662 663 664 665 666 667 668 669
	i=$(find "$dir" -type f -perm +6000 \
		| xargs scanelf --nobanner --etype ET_EXEC \
		| sed "s|ET_EXEC $dir|\t|")
	if [ -n "$i" ]; then
		error "Found non-PIE files that has SUID:"
		echo "$i"
		return 1
	fi
Natanael Copa's avatar
Natanael Copa committed
670 671 672 673 674 675 676 677 678
	# test for textrels
	if ! options_has "textrels"; then
		local res="$(scanelf --recursive --textrel --quiet "$dir")"
		if [ -n "$res" ]; then
			error "Found textrels:"
			echo "$res"
			return 1
		fi
	fi
679 680 681
	return 0
}

682
prepare_subpackages() {
Natanael Copa's avatar
Natanael Copa committed
683 684
	local i
	cd "$startdir"
685
	for i in $subpackages; do
Natanael Copa's avatar
Natanael Copa committed
686 687
		local func=$(get_split_func $i)
		# call abuild recursively, setting subpkg{dir,name}
688
		msg "Running split function $func..."
689
		local dir="$pkgbasedir/${i%:*}" name="${i%:*}"
690 691 692
		( subpkgdir="$dir" subpkgname="$name" \
			$0 $func prepare_package \
			&& postcheck "$dir" "$name" ) || return 1
Natanael Copa's avatar
Natanael Copa committed
693
	done
694
	postcheck "$pkgdir" "$pkgname" || return 1
695 696
	# post check for /usr/share/locale
	if [ -d "$pkgdir"/usr/share/locale ]; then
697
		warning "Found /usr/share/locale"
698
		warning2 "Maybe add \$pkgname-lang to subpackages?"
699
	fi
Natanael Copa's avatar
Natanael Copa committed
700 701
}

702
default_lang() {
703
	pkgdesc="Languages for package $pkgname"
704 705 706 707 708 709 710 711 712 713 714 715 716
	install_if="$pkgname=$pkgver-r$pkgrel lang"
	arch="noarch"
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/${dir%/*}
		mv "$pkgdir"/"$dir" "$subpkgdir"/"$dir" || return 1
	done
}

lang() {
	default_lang
}

717
default_lang_subpkg() {
718 719 720 721
	if [ -z "$lang" ]; then
		error "lang is not set"
		return 1
	fi
722
	pkgdesc="$pkgname language pack for $lang"
723 724
	arch="noarch"
	install_if="$pkgname=$pkgver-r$pkgrel lang-$lang"
725 726 727 728 729
	local dir
	for dir in ${langdir:-/usr/share/locale}; do
		mkdir -p "$subpkgdir"/$dir
		mv "$pkgdir"/$dir/$lang* \
		"$subpkgdir"/$dir/ \
730
		|| return 1
731 732 733 734 735
	done
}

lang_subpkg() {
	default_lang_subpkg
736 737 738 739 740 741 742 743 744 745 746
}

prepare_language_packs() {
	for lang in $linguas; do
		lang="$lang" \
		subpkgname="$pkgname-lang-$lang" \
		subpkgdir="$pkgbasedir"/$subpkgname \
			$0 lang_subpkg prepare_package || return 1
	done
}

747 748 749 750 751 752 753 754 755 756 757 758
# echo '-dirty' if git is not clean
git_dirty() {
	if [ $(git status -s "$startdir" | wc -l) -ne 0 ]; then
		echo "-dirty"
	fi
}

# echo last commit hash id
git_last_commit() {
	git log --format=oneline -n 1 "$startdir" | awk '{print $1}'
}

759 760 761 762 763 764
get_maintainer() {
	if [ -z "$maintainer" ]; then
		maintainer=$(awk -F': ' '/\# *Maintainer/ {print $2}' "$APKBUILD")
	fi
}

765
prepare_metafiles() {
766
	getpkgver || return 1
767 768
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
769
	local dir=${subpkgdir:-$pkgdir}
770
	local pkg="$name-$pkgver-r$pkgrel.apk"
771
	local pkginfo="$controldir"/.PKGINFO
772
	local sub
773

Natanael Copa's avatar
Natanael Copa committed
774 775
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
776
	mkdir -p "$controldir"
Natanael Copa's avatar
Natanael Copa committed
777 778
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')
Natanael Copa's avatar
Natanael Copa committed
779
	local parch="$CARCH"
780 781 782 783 784

	# we need to wait with setting noarch til our build infra can handle it
#	if [ "$arch" = "noarch" ]; then
#		parch="noarch"
#	fi
Natanael Copa's avatar
Natanael Copa committed
785

786
	echo "# Generated by $(basename $0) $abuild_ver" >"$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
787
	if [ -n "$FAKEROOTKEY" ]; then
788
		echo "# using $($FAKEROOT -v)" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
789
	fi
790 791
	echo "# $(date -u)" >> "$pkginfo"
	cat >> "$pkginfo" <<EOF
792
pkgname = $name
793
pkgver = $pkgver-r$pkgrel
Natanael Copa's avatar
Natanael Copa committed
794 795 796 797 798
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
Natanael Copa's avatar
Natanael Copa committed
799
arch = $parch
Natanael Copa's avatar
Natanael Copa committed
800
origin = $pkgname
Natanael Copa's avatar
Natanael Copa committed
801
EOF
802 803
	local i deps
	deps="$depends"
804
	if [ "$pkgname" != "busybox" ] && ! depends_has busbox; then
805 806
		for i in $install $triggers; do
			local s=${i%=*}
807
			[ "$name" != "${s%.*}" ] && continue
808
			if head -n 1 "$startdir/$s" | grep '^#!/bin/sh' >/dev/null ; then
809 810 811 812 813
				msg "Script found. busybox added as a dependency for $pkg"
				deps="$deps busybox"
				break
			fi
		done
814
	fi
815

816 817 818
	# store last_commit in global var so we only call git once
	if [ -z "$last_commit" ]; then
		last_commit="$(git_last_commit)$(git_dirty)"
819
	fi
820
	echo "commit = $last_commit" >> "$pkginfo"
821 822 823 824 825 826

	get_maintainer
	if [ -n "$maintainer" ]; then
		echo "maintainer = $maintainer" >> "$pkginfo"
	fi

827
	if [ -n "$replaces_priority" ]; then
Natanael Copa's avatar
Natanael Copa committed
828
		echo "replaces_priority = $replaces_priority" >> "$pkginfo"
829 830
	fi

Natanael Copa's avatar
Natanael Copa committed
831
	for i in $license; do
832
		echo "license = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
833 834
	done
	for i in $replaces; do
835
		echo "replaces = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
836
	done
837
	for i in $deps; do
838
		echo "depend = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
839 840
	done
	for i in $conflicts; do
841
		echo "conflict = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
842 843
	done
	for i in $provides; do
844
		echo "provides = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
845
	done
846 847 848 849 850 851
	for i in $triggers; do
		local f=${i%=*}
		local dirs=${i#*=}
		[ "${f%.trigger}" != "$name" ] && continue
		echo "triggers = ${dirs//:/ }" >> "$pkginfo"
	done
852 853 854
	if [ -n "$install_if" ]; then
		echo "install_if = $(echo $install_if)" >> "$pkginfo"
	fi
Natanael Copa's avatar
Natanael Copa committed
855 856

	local metafiles=".PKGINFO"
857 858 859
	for i in $install $triggers; do
		local f=${i%=*}
		local n=${f%.*}
860
		if [ "$n" != "$name" ]; then
861 862
			continue
		fi
863
		script=${f#$name}
864
		msg "Adding $script"
865
		cp "$startdir/$f" "$controldir/$script" || return 1
866
		chmod +x "$controldir/$script"
867 868
		metafiles="$metafiles $script"
	done
869
	echo $metafiles | tr ' ' '\n' > "$controldir"/.metafiles
870
}
871

872 873
prepare_tracedeps() {
	local dir=${subpkgdir:-$pkgdir}
874
	local etype= soname= file= sover=
875
	[ "$arch" = "noarch" ] && return 0
876
	options_has "!tracedeps" && return 0
877
	# lets tell all the places we should look for .so files - all rpaths
878 879
	scanelf --quiet --recursive --rpath "$dir" \
		| sed -e 's/[[:space:]].*//' -e 's/:/\n/' | sort -u \
880
		>"$controldir"/.rpaths
881 882 883 884 885 886 887
	if grep -q -x '/usr/lib' "$controldir"/.rpaths; then
		warning "Redundat /usr/lib in rpath found"
	fi
	if grep '^/home/' "$controldir"/.rpaths; then
		error "Has /home/... in rpath"
		return 1
	fi
Natanael Copa's avatar
Natanael Copa committed
888 889
}

890 891 892 893 894 895 896 897 898 899 900 901
# check if dir has arch specific binaries
dir_has_arch_binaries() {
	local dir="$1"
	# if scanelf returns something, then we have binaries
	[ -n "$(scanelf -R "$dir" | head -n 1)" ] && return 0

	# look for static *.a
	[ -n "$(find "$dir" -type f -name '*.a' | head -n 1)" ] && return 0

	return 1
}

902 903 904 905 906
# returns true if this is the -dev package
is_dev_pkg() {
	test "${subpkgname%-dev}" != "$subpkgname"
}

907 908 909 910 911 912 913
# check that noarch is set if needed
archcheck() {
	options_has "!archcheck" && return 0
	if dir_has_arch_binaries "${subpkgdir:-$pkgdir}"; then
		[ "$arch" != "noarch" ] && return 0
		error "Arch specific binaries found so arch must not be set to \"noarch\""
		return 1
914 915 916
	elif [ "$arch" != "noarch" ] && ! is_dev_pkg; then
		# we dont want -dev package go to noarch
		warning "No arch specific binaries found so arch should probably be set to \"noarch\""
917 918 919 920
	fi
	return 0
}

921
prepare_package() {
922
	msg "Preparing ${subpkgname:+sub}package ${subpkgname:-$pkgname}..."
923
	stripbin
924
	prepare_metafiles && prepare_tracedeps || return 1
925
	archcheck
926 927 928 929 930 931 932 933
}

pkginfo_val() {
	local key="$1"
	local file="$2"
	awk -F ' = ' "\$1 == \"$key\" {print \$2}" "$file"
}

934 935 936 937 938 939 940 941 942 943 944 945 946 947 948 949 950 951 952 953 954 955 956
# find real path to so files
real_so_path() {
	local so="$1"
	shift
	while [ $# -gt 0 ]; do
		[ -e "$1"/$so ] && realpath "$1/$so" && return 0
		shift
	done
	error "$so: path not found"
	return 1
}

# search rpaths and /usr/lib /lib for given so files
find_so_files() {
	local rpaths=$(cat "$1")
	shift
	while [ $# -gt 0 ]; do
		real_so_path "$1" /usr/lib /lib $rpaths || return 1
		shift
	done
	return 0
}

957 958 959 960
subpkg_provides() {
	grep -q -w "^$1" "$pkgbasedir"/.control.*/.provides-so 2>/dev/null
}

961 962 963
trace_apk_deps() {
	local name="$1"
	local dir="$2"
964
	local i= found= autodeps= deppkgs= missing=
965
	msg "Tracing dependencies..."
966 967 968
	# add pkgconfig if usr/lib/pkgconfig is found
	if [ -d "$pkgbasedir"/$name/usr/lib/pkgconfig ] \
			&& ! grep -q '^depend = pkgconfig' "$dir"/.PKGINFO; then
969
		msg "  added pkgconfig (found /usr/lib/pkgconfig)"
970 971 972 973
		autodeps="$autodeps pkgconfig"
	fi

	# special case for libpthread: we need depend on libgcc
974
	if [ -f "$dir"/.needs-so ] && grep -q -w '^libpthread.so.*' "$dir"/.needs-so \
975 976
			&& ! grep -q -w "^depend = libgcc" "$dir"/.PKGINFO; then
		autodeps="$autodeps libgcc"
977
		msg "  added libgcc (due to libpthread)"
978
	fi
979
	[ -f "$dir"/.needs-so ] && for i in $(cat "$dir"/.needs-so); do
980 981 982
		# first check if its provided by same apkbuild
		grep -q -w "^$i" "$dir"/.provides-so 2>/dev/null && continue

983 984
		if subpkg_provides "$i" || [ "$CBUILD" != "$CHOST" ] \
				|| $APK info --quiet --installed "so:$i"; then
985
			autodeps="$autodeps so:$i"
986
		else
987
			missing="$missing $i"
988
		fi
989 990 991
	done

	# find all packages that holds the so files
992
	if [ -f "$dir"/.rpaths ]; then
993 994
		local so_files=$(find_so_files "$dir"/.rpaths $missing) \
			|| return 1
995
		deppkgs=$($APK info --quiet --who-owns $so_files) || return 1
996 997
	fi

998
	for found in $deppkgs; do
999
		if grep -w "^depend = ${found}$" "$dir"/.PKGINFO >/dev/null ; then
1000 1001 1002
			warning "You can remove '$found' from depends"
			continue
		fi
1003
		autodeps="$autodeps $found"
1004
	done
1005

1006
	echo "# automatically detected:" >> "$dir"/.PKGINFO
1007
	if [ -f "$dir"/.provides-so ]; then
1008
		sed 's/^\(.*\) \([0-9].*\)/provides = so:\1=\2/' "$dir"/.provides-so \
1009
			>> "$dir"/.PKGINFO
1010 1011
	fi
	[ -z "$autodeps" ] && return 0
1012
	for i in $autodeps; do
1013 1014
		echo "depend = $i"
	done | sort -u >> "$dir"/.PKGINFO
1015 1016
	# display all depends
	sed -n '/^depend =/s/depend = /\t/p' "$dir"/.PKGINFO >&2
1017 1018
}

1019
find_scanelf_paths() {
1020
	local datadir="$1"
Natanael Copa's avatar
Natanael Copa committed
1021
	local paths="$datadir/lib:$datadir/usr/lib" i= rpaths=
1022
	if [ -n "$ldpath" ]; then
1023
		paths="$paths:$(echo "$ldpath" | sed "s|\(^\|:\)|\1$datadir|g")"
1024 1025
	fi
	# search in all rpaths
Natanael Copa's avatar
Natanael Copa committed
1026 1027
	for rpaths in "$pkgbasedir"/.control.*/.rpaths; do
		[ -f "$rpaths" ] || continue
1028
		while read i; do
1029 1030 1031 1032
			local dir="${datadir}${i}"
			IFS=:
			if [ -d "$dir" ] && ! list_has "$dir" $paths; then
				paths="$paths:${dir}"
1033
			fi
1034
			unset IFS
Natanael Copa's avatar
Natanael Copa committed
1035
		done < "$rpaths"
1036 1037 1038 1039 1040 1041
	done
	echo "$paths"
}

scan_shared_objects() {
	local name="$1" controldir="$2" datadir="$3"
1042
	local opt=
1043 1044 1045

	# allow spaces in paths
	IFS=:
1046
	set -- $(find_scanelf_paths "$datadir")
1047 1048
	unset IFS

1049 1050 1051
	if options_has "ldpath-recursive"; then
		opt="--recursive"
	fi
1052 1053
	msg "Scanning shared objects"
	# lets tell all the .so files this package provides in .provides-so
1054
	scanelf --nobanner --soname $opt "$@" | while read etype soname file; do
1055 1056
		# if soname field is missing, soname will be the filepath
		sover=0
1057 1058
		if [ -z "$file" ]; then
			file="$soname"
1059
			soname=${soname##*/}
1060 1061 1062 1063
		fi

		# we only want shared libs
		case $soname in
1064
		*.so|*.so.[0-9]*|*.c32);;
1065 1066 1067 1068 1069 1070 1071 1072 1073
		*) continue;;
		esac

		case "$file" in
		*.so.[0-9]*) sover=${file##*.so.};;
		*.so)
			# filter out sonames with version when file does not
			# have version
			case "$soname" in
1074 1075 1076 1077
			*.so.[0-9]*)
				if options_has "sover-namecheck"; then
					continue
				fi
1078 1079 1080
			esac
			;;
		esac
Natanael Copa's avatar
Natanael Copa committed
1081
		list_has "$soname" $somask && continue
1082
		echo "$soname $sover"
1083 1084 1085 1086 1087 1088 1089 1090 1091 1092
	# use awk to filter out dupes that has sover = 0
	done | awk '{ if (so[$1] == 0) so[$1] = $2; }
		END { for (i in so) print(i " " so[i]); }' \
		| sort -u > "$controldir"/.provides-so

	# verify that we dont have any duplicates
	local dupes="$(cut -d' ' -f1 "$controldir"/.provides-so | uniq -d)"
	if [ -n "$dupes" ]; then
		die  "provides multiple versions of same shared object: $dupes"
	fi
1093 1094 1095 1096 1097

	# now find the so dependencies
	scanelf --nobanner --recursive --needed "$datadir"  | tr ' ' ':' \
		| awk -F ":" '$1 == "ET_DYN" || $1 == "ET_EXEC" {print $2}'  \
		| sed 's:,:\n:g' | sort -u \
Natanael Copa's avatar
Natanael Copa committed
1098
	| while read soname; do